/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.myorg.ddlvisualizer;

import javax.swing.text.Document;
import org.netbeans.api.languages.ParseException;
import org.netbeans.api.languages.ParserManager;
import org.openide.cookies.EditorCookie;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;

public final class ShowDiagram extends CookieAction {

    protected void performAction(Node[] activatedNodes) {
        try {
            EditorCookie editorCookie = activatedNodes[0].getLookup().lookup(EditorCookie.class);
            Document doc = editorCookie.getDocument();
            ParserManager pm = ParserManager.get(doc);

            VisualizerTopComponent win = VisualizerTopComponent.findInstance();
            win.getScene().setASTNode(pm.getAST());
            win.open();
            win.requestActive();
        } catch (ParseException ex) {
            Exceptions.printStackTrace(ex);
        }
    }

    protected int mode() {
        return CookieAction.MODE_EXACTLY_ONE;
    }

    public String getName() {
        return NbBundle.getMessage(ShowDiagram.class, "CTL_ShowDiagram");
    }

    protected Class[] cookieClasses() {
        return new Class[]{EditorCookie.class};
    }

    @Override
    protected void initialize() {
        super.initialize();
        // see org.openide.util.actions.SystemAction.iconResource() Javadoc for more details
        putValue("noIconInMenu", Boolean.TRUE);
    }

    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }

    @Override
    protected boolean asynchronous() {
        return false;
    }
}

